#ifndef SYSFCNTLH_
#define SYSFCNTLH_

#define O_BINARY             0
#define O_TEXT               0

#define O_RDONLY        0
#define O_WRONLY        1
#define O_RDWR          2
#define O_ACCMODE       3       /* Mask for file access modes */

#define O_CREAT         0x100   /* open with file create (uses third open arg) */
#define O_EXCL          0x400   /* exclusive open */
#define O_NOCTTY        0x800   /* don't allocate controlling tty (POSIX) */
#define O_TRUNC         0x200   /* open with truncation */

#define O_NONBLOCK      0x80    /* non-blocking I/O (POSIX) */
#define O_APPEND        0x08    /* append (writes guaranteed at the end) */

#define O_NDELAY        0x04    /* non-blocking I/O */
#define O_SYNC          0x10    /* synchronous write option */
#define FASYNC          0x1000  /* interrupt-driven I/O for sockets */


#define FD_CLOEXEC      1       /* close on exec flag */

#define F_DUPFD         0       /* Duplicate fildes */
#define F_GETFD         1       /* Get fildes flags */
#define F_SETFD         2       /* Set fildes flags */
#define F_GETFL         3       /* Get file flags */
#define F_SETFL         4       /* Set file flags */

#define F_GETLK         14      /* Get file lock */

#define F_SETLK         6       /* Set file lock */
#define F_SETLKW        7       /* Set file lock and wait */


/*
 * File segment locking types.
 */
#define F_RDLCK 01      /* Read lock */
#define F_WRLCK 02      /* Write lock */
#define F_UNLCK 03      /* Remove lock(s) */

/*
 * File segment locking set data type - information passed to system by user.
 */

typedef struct flock {
        short   l_type;
        short   l_whence;
        off_t   l_start;
        off_t   l_len;          /* len == 0 means until end of file */
        long    l_sysid;
        pid_t   l_pid;
        long    pad[4];         /* reserve area */
} flock_t;

#endif







