#ifndef SYSFCNTLH_
#define SYSFCNTLH_

#define O_BINARY             0
#define O_TEXT               0
#define O_ACCMODE         0003
#define O_RDONLY            00
#define O_WRONLY            01
#define O_RDWR              02
#define O_CREAT          0x100
#define O_EXCL           0x400
#define O_NOCTTY         0x800
#define O_TRUNC          0x200
#define O_APPEND          0x08	
#define O_NONBLOCK        0x80	
#define O_NDELAY          0x04
#define O_SYNC            0x10
#define FASYNC          0x1000 

#define FD_CLOEXEC      1       /* close on exec flag */

#define F_DUPFD         0       /* Duplicate fildes */
#define F_GETFD         1       /* Get fildes flags */
#define F_SETFD         2       /* Set fildes flags */
#define F_GETFL         3       /* Get file flags */
#define F_SETFL         4       /* Set file flags */

#define F_GETLK         14      /* Get file lock */

#define F_SETLK         6       /* Set file lock */
#define F_SETLKW        7       /* Set file lock and wait */

#define F_RDLCK         01      /* Read lock */
#define F_WRLCK         02      /* Write lock */
#define F_UNLCK         03      /* Remove lock(s) */


typedef struct flock {
        short   l_type;
        short   l_whence;
        off_t   l_start;
        off_t   l_len;          /* len == 0 means until end of file */
        long    l_sysid;
        pid_t   l_pid;
        long    l_pad[4];               /* reserve area */
} flock_t;

#endif






