#ifndef _SYSTERMIOSH
#define	_SYSTERMIOSH


typedef unsigned long tcflag_t;
typedef unsigned char cc_t;
typedef unsigned long speed_t;


#define	NCC	8
struct termio {
	unsigned short c_iflag;		/* input mode flags */
	unsigned short c_oflag;		/* output mode flags */
	unsigned short c_cflag;		/* control mode flags */
	unsigned short c_lflag;		/* local mode flags */
	unsigned char c_line;		/* line discipline */
	unsigned char c_cc[NCC];	/* control characters */
};

#define	NCCS	19
struct termios {
	tcflag_t	c_iflag;	/* input modes */
	tcflag_t	c_oflag;	/* output modes */
	tcflag_t	c_cflag;	/* control modes */
	tcflag_t	c_lflag;	/* line discipline modes */
	cc_t		c_cc[NCCS];	/* control chars */
};


#define	B0	0
#define	B50	1
#define	B75	2
#define	B110	3
#define	B134	4
#define	B150	5
#define	B200	6
#define	B300	7
#define	B600	8
#define	B1200	9
#define	B1800	10
#define	B2400	11
#define	B4800	12
#define	B9600	13
#define	B19200	14
#define	B38400	15


/* c_cflag  */
#define	CLOCAL	0004000
#define	CS5	0
#define	CS6	0000020
#define	CS7	0000040
#define	CS8	0000060
#define	CSIZE	0000060
#define	CSTOPB	0000100
#define	HUPCL	0002000
#define	PARENB	0000400
#define	PARODD	0001000


/* c_iflag  modes */
#define	BRKINT	0000002
#define	ICRNL	0000400
#define	IGNBRK	0000001
#define	IGNCR	0000200
#define	IGNPAR	0000004
#define	INLCR	0000100
#define	INPCK	0000020
#define	ISTRIP	0000040
#define	IXANY	0004000
#define	IXOFF	0010000
#define	IXON	0002000
#define	PARMRK	0000010

/* c_lfag bits */
#define	ECHO	0000010
#define	ECHOE	0000020
#define	ECHOK	0000040
#define	ECHONL	0000100
#define	ICANON	0000002
#define	IEXTEN	0100000  /* POSIX flag - enable POSIX extensions */
#define	ISIG	0000001
#define	NOFLSH	0000200
#define	TOSTOP	0000400

/* c_oflag bits */
#define	OPOST	0000001


/* c_cc  characters */
#define	VEOF	4
#define	VEOL	5
#define	VERASE	2
#define	VINTR	0
#define	VKILL	3
#define	VMIN	4
#define	VQUIT	1
#define	VSTART		8
#define	VSTOP		9
#define	VSUSP		10
#define	VTIME	5

/* c_cc characters for 4.3+BSD */
#define	VDISCARD	13
#define	VDSUSP		11
#define	VEOL2	6
#define	VLNEXT		15
#define	VREPRINT	12
#define	VWERASE		14

/* tcflow() and TCXONC use these */
#define	TCOOFF		0  /* suspend output */
#define	TCOON		1  /* restart suspended output */
#define	TCIOFF		2  /* suspend input */
#define	TCION		3  /* restart suspended input */

/* tcflush() and TCFLSH use these */
#define	TCIFLUSH	0  /* flush data received but not read */
#define	TCOFLUSH	1  /* flush data written but not transmitted */
#define	TCIOFLUSH	2  /* flush both data both input and output queues */

#define	_TIOC	('T'<<8)

/* tcsetattr uses these */
#define	TCSADRAIN	(_TIOC|15) /* same as TCSETSW */
#define	TCSAFLUSH	(_TIOC|16) /* same as TCSETSF */
#define	TCSANOW		(_TIOC|14) /* same as TCSETS */


#endif 

