#ifndef SYSFCNTLH_
#define SYSFCNTLH_

#define O_BINARY             0
#define O_TEXT               0
#define O_ACCMODE         0003
#define O_RDONLY            00
#define O_WRONLY            01
#define O_RDWR              02
#define O_CREAT         0x0200
#define O_EXCL          0x0800	
#define O_NOCTTY        0x8000
#define O_TRUNC         0x0400
#define O_APPEND        0x0008	
#define O_NONBLOCK      0x4000	
#define O_NDELAY        0x0004
#define O_SYNC          0x2000	
#define FASYNC          0x0040	

#define FD_CLOEXEC      1       /* posix */
/* fcntl(2) requests */
#define F_DUPFD         0       /* Duplicate fildes */
#define F_GETFD         1       /* Get fildes flags (close on exec) */
#define F_SETFD         2       /* Set fildes flags (close on exec) */
#define F_GETFL         3       /* Get file flags */
#define F_SETFL         4       /* Set file flags */
#define F_GETLK         7       /* Get record-locking information */
#define F_SETLK         8       /* Set or Clear a record-lock (Non-Blocking) */
#define F_SETLKW        9       /* Set or Clear a record-lock (Blocking) */

/* fcntl(2) flags (l_type field of flock structure) */
#define F_RDLCK         1       /* read lock */
#define F_WRLCK         2       /* write lock */
#define F_UNLCK         3       /* remove lock(s) */


struct flock {
        short   l_type;         /* F_RDLCK, F_WRLCK, or F_UNLCK */
        short   l_whence;       /* flag to choose starting offset */
        long    l_start;        /* relative offset, in bytes */
        long    l_len;          /* length, in bytes; 0 means lock to EOF */
        short   l_pid;          /* returned with F_GETLK */
        short   l_xxx;          /* reserved for future use */
};
#endif
