#ifndef	_SYSTERMIOSH
#define	_SYSTERMIOSH

typedef unsigned int    speed_t;        /* tty speeds */
typedef unsigned long   tcflag_t;       /* tty line disc modes */
typedef unsigned char   cc_t;           /* tty control char */


#define	NCCS	17
struct	termios {
	tcflag_t	c_iflag;	/* input modes */
	tcflag_t	c_oflag;	/* output modes */
	tcflag_t	c_cflag;	/* control modes */
	tcflag_t	c_lflag;	/* line discipline modes */
	char		c_line;		/* line discipline XXX */
	cc_t		c_cc[NCCS];	/* control chars */
};

/*
 * Speeds
 */

#define	B0	0
#define	B50	1
#define	B75	2
#define	B110	3
#define	B134	4
#define	B150	5
#define	B200	6
#define	B300	7
#define	B600	8
#define	B1200	9
#define	B1800	10
#define	B2400	11
#define	B4800	12
#define	B9600	13
#define	B19200	14
#define	B38400	15

/* c_cflag  modes */
#define	CLOCAL	0x00000800
#define	CS5	0
#define	CS6	0x00000010
#define	CS7	0x00000020
#define	CS8	0x00000030
#define	CSIZE	0x00000030
#define	CSTOPB	0x00000040
#define	HUPCL	0x00000400
#define	PARENB	0x00000100
#define	PARODD	0x00000200

/* c_iflag bits input */
#define	BRKINT	0x00000002
#define	ICRNL	0x00000100
#define	IGNBRK	0x00000001
#define	IGNCR	0x00000080
#define	IGNPAR	0x00000004
#define	INLCR	0x00000040
#define	INPCK	0x00000010
#define	ISTRIP	0x00000020
#define	IXOFF	0x00001000
#define	IXON	0x00000400
#define	PARMRK	0x00000008

/* c_lflag bits */
#define	ECHO	0x00000008
#define	ECHOE	0x00000010
#define	ECHOK	0x00000020
#define	ECHONL	0x00000040
#define	ICANON	0x00000002
#define	IEXTEN	0x00008000
#define	ISIG	0x00000001
#define	NOFLSH	0x00000080
#define	TOSTOP	0x00000100

/* c_oflag output modes */
#define	OPOST	0x00000001

/* c_cc characters */
#define	VEOF		4
#define	VEOL		5
#define	VERASE		2
#define	VINTR		0
#define	VKILL		3
#define	VMIN		VEOF
#define	VQUIT		1
#define	VSTART		8
#define	VSTOP		9
#define	VSUSP		10
#define	VTIME		VEOL

/* c_cc characters for 4.3+BSD compatibility */
#define	VDISCARD	13
#define	VDSUSP		11
#define	VEOL2		6
#define	VLNEXT		15
#define	VSTATUS		16
#define	VREPRINT	12
#define	VWERASE		14

/* tcflow() and TCXONC use these */
#define	TCOOFF		0		/* arg to TCXONC & tcflow() */
#define	TCOON		1		/* arg to TCXONC & tcflow() */
#define	TCIOFF		2		/* arg to TCXONC & tcflow() */
#define	TCION		3		/* arg to TCXONC & tcflow() */

/* tcflush() and TCFLSH use these */
#define	TCIFLUSH	0		/* arg to TCFLSH & tcflush() */
#define	TCOFLUSH	1		/* arg to TCFLSH & tcflush() */
#define	TCIOFLUSH	2		/* arg to TCFLSH & tcflush() */

/* tcsetattr uses these */
#define	TCSANOW		0		/* arg to tcsetattr() */
#define	TCSADRAIN	1		/* arg to tcsetattr() */
#define	TCSAFLUSH	2		/* arg to tcsetattr() */

#endif	/* _SYSTERMIOSH */

